<template>
  <div :class="classObject" :data-index="index">
    <div v-if="showInfo" class="pc__info-container">
      <div class="pc__info">
        <div class="pc__info-title">{{ title }}</div>
        <div class="pc__info-tags-container">
          <tag-component
            class="pc__tag"
            :label="{ text: 'PX', color: 'white', backgroundColor: 'black' }"
            :value="{ text: resolution, color: 'white', backgroundColor: 'red' }"
          />
          <tag-component
            class="pc__tag"
            :label="{ text: 'MINS', color: 'white', backgroundColor: '#317ddc' }"
            :value="{ text: duration, color: 'white', backgroundColor: 'red' }"
          />
          <tag-component
            class="pc__tag"
            :label="{ text: 'YEAR', color: 'white', backgroundColor: '#1c901c' }"
            :value="{ text: year, color: 'white', backgroundColor: 'red' }"
          />
          <div class="pc__plot">
            <div class="pc__plot-text">
              {{ plot }}
            </div>
          </div>
        </div>
      </div>
      <div class="pc__action-container">
        <font-awesome-icon
          icon="question-circle"
          class="pc__info-icon"
          @click="showInfo = !showInfo"
        />
        <font-awesome-icon v-if="playing" class="pc__info-icon" icon="spinner" spin />
        <font-awesome-icon
          v-if="!playing && showInfo"
          icon="play-circle"
          class="pc__info-icon"
          @click="handleOpenVideo"
        />
      </div>
    </div>
    <img
      component="poster place holder"
      :data-full-path="fullPath"
      :src="prevSrc"
      :alt="alt"
      class="pc__img"
    >
    <div v-if="!showInfo" class="pc__img-action">
      <font-awesome-icon
        icon="question-circle"
        class="pc__info-icon"
        @click="showInfo = !showInfo"
      />
    </div>
  </div>
</template>

<script>
import floor from 'lodash/floor';
import ceil from 'lodash/ceil';
import get from 'lodash/get';
import TagComponent from '@dashboard/components/Tag.vue';
import { EMPTY_STRING } from '@/common/helpers/constants';
import placeHolder from '../../../assets/place-holder.jpg';

export default {
  name: 'PorsterContainer',
  components: { TagComponent },
  props: {
    src: {
      type: String,
      default: EMPTY_STRING,
    },
    alt: {
      type: String,
      default: EMPTY_STRING,
    },
    doc: {
      type: Object,
      default: () => ({}),
    },
    index: {
      type: Number,
      default: 0,
    },
    total: {
      type: Number,
      default: 0,
    },
  },
  data() {
    return {
      playing: false,
      prevSrc: placeHolder,
      showInfo: false,
      classObject: {
        pc__container: true,
        'pc__container-first-top': false,
        'pc__container-middle-top': false,
        'pc__container-last-top': false,
        'pc__container-first-middle': false,
        'pc__container-middle-middle': false,
        'pc__container-last-middle': false,
        'pc__container-first-bottom': false,
        'pc__container-middle-bottom': false,
        'pc__container-last-bottom': false,
      },
    };
  },
  computed: {
    fullPath() {
      return get(this.doc, 'files.movie.fullPath', {});
    },
    movie() {
      return get(this.doc, 'movie', {});
    },
    title() {
      return get(this.doc, 'movie.title', EMPTY_STRING);
    },
    plot() {
      return get(this.doc, 'movie.plot', EMPTY_STRING);
    },
    year() {
      return get(this.doc, 'movie.year', '0000');
    },
    resolution() {
      const w = get(this.doc, 'movie.fileinfo.streamdetails.video.width', 0);
      const h = get(this.doc, 'movie.fileinfo.streamdetails.video.height', 0);
      return `${w}x${h}`;
    },
    duration() {
      return get(this.doc, 'movie.fileinfo.streamdetails.video.duration', 0);
    },
  },
  mounted() {
    const image = new Image();
    image.onload = () => {
      this.prevSrc = this.src;
      this.$emit('image:loaded', this.alt);
      this.showInfo = false;
    };
    image.onerror = () => {
      this.showInfo = true;
    };
    image.src = this.src;
    this.resolveAnimation();
  },
  methods: {
    handleOpenVideo() {
      this.playing = true;
      const fullPath = get(this.doc, 'files.movie.fullPath', EMPTY_STRING);
      window.ipcRenderer.invoke('open:video', { file: fullPath })
        .then(() => {
          setTimeout(() => {
            this.playing = false;
          }, 2000);
        });
    },
    resolveAnimation() {
      const imgByRow = Math.round(this.$parent.$el.clientWidth / this.$el.clientWidth);
      const row = floor(this.index / imgByRow);
      const lastRow = ceil(this.total / imgByRow);

      const isMiddle = () => row > 0 && row < lastRow - 1;
      const isMiddleFirst = index => isMiddle() && index === (row * imgByRow);
      const isMiddleMiddle = index => isMiddle()
        && index > (row * imgByRow) && index < ((row * imgByRow) + imgByRow - 1)
        && index !== ((row * imgByRow) + imgByRow - 1);
      const isMiddleLast = index => isMiddle()
        && index === ((row * imgByRow) + (imgByRow - 1));

      const isBottom = () => row === lastRow - 1;
      const isBottomFirst = index => isBottom() && index === (row * imgByRow);
      const isBottomMiddle = index => isBottom()
        && index > (row * imgByRow) && index !== (lastRow * imgByRow) - 1;
      const isBottomLast = index => isBottom() && index === (lastRow * imgByRow) - 1;

      // eslint-disable-next-line no-console, max-len
      // console.log(`total: ${this.total} lastRow: ${lastRow}, index: ${this.index}, row: ${row}, imgByRow: ${imgByRow}, ${isBottom()}`);

      this.classObject.pc__container = false;
      if (this.index === 0) {
        this.classObject['pc__container-first-top'] = true;
      } else if (this.index > 0 && this.index < imgByRow && this.index !== imgByRow - 1) {
        this.classObject['pc__container-middle-top'] = true;
      } else if (this.index === imgByRow - 1) {
        this.classObject['pc__container-last-top'] = true;
      } else if (isMiddleFirst(this.index)) {
        this.classObject['pc__container-first-middle'] = true;
      } else if (isMiddleMiddle(this.index)) {
        this.classObject['pc__container-middle-middle'] = true;
      } else if (isMiddleLast(this.index)) {
        this.classObject['pc__container-last-middle'] = true;
      } else if (isBottomFirst(this.index)) {
        this.classObject['pc__container-first-bottom'] = true;
      } else if (isBottomMiddle(this.index)) {
        this.classObject['pc__container-middle-bottom'] = true;
      } else if (isBottomLast(this.index)) {
        this.classObject['pc__container-last-bottom'] = true;
      }
    },
  },
};
</script>

<style lang="scss" scoped>
.pc__container {
  position: relative;
  width: 20%;
  height: auto;
  flex-shrink: 0;
  transition: all 1s;
}

// FIRST
.pc__container-first-top {
  @extend .pc__container;
}

.pc__container-first-top:hover {
  transform: scale(1.2) translateX(100px) translateY(50px);
  z-index: 1;
  transition-delay:.4s;
}

.pc__container-middle-top {
  @extend .pc__container;
}

.pc__container-middle-top:hover {
  transform: scale(1.2) translateY(50px);
  z-index: 1;
  transition-delay:.4s;
}

.pc__container-last-top {
  @extend .pc__container;
}

.pc__container-last-top:hover {
  transform: scale(1.2) translateX(-100px) translateY(50px);
  z-index: 1;
  transition-delay:.4s;
}

// MIDDLE
.pc__container-first-middle {
  @extend .pc__container;
}

.pc__container-first-middle:hover {
  transform: scale(1.2) translateX(100px);
  z-index: 1;
  transition-delay:.4s;
}

.pc__container-middle-middle {
  @extend .pc__container;
}

.pc__container-middle-middle:hover {
  transform: scale(1.2);
  z-index: 1;
  transition-delay:.4s;
}

.pc__container-last-middle {
  @extend .pc__container;
}

.pc__container-last-middle:hover {
  transform: scale(1.2) translateX(-100px);
  z-index: 1;
  transition-delay:.4s;
}

// BOTTOM
.pc__container-first-bottom {
  @extend .pc__container;
}

.pc__container-first-bottom:hover {
  transform: scale(1.2) translateX(100px) translateY(-50px);
  z-index: 1;
  transition-delay:.4s;
}

.pc__container-middle-bottom {
  @extend .pc__container;
}

.pc__container-middle-bottom:hover {
  transform: scale(1.2) translateY(-50px);
  z-index: 1;
  transition-delay:.4s;
}

.pc__container-last-bottom {
  @extend .pc__container;
}

.pc__container-last-bottom:hover {
  transform: scale(1.2) translateX(-100px) translateY(-50px);
  z-index: 1;
  transition-delay:.4s;
}

.pc__img {
  width: 100%;
  height: 100%;
  flex-shrink: 0;
  border: solid 1px #dcdbdb;
}

.pphc__placehoder {
  min-width: 275px;
  min-height: 400px;
  padding: 1rem;
  display: flex;
  align-items: center;
  justify-content: center;
  flex-grow: 1;
  border: solid 1px #dcdbdb;
  background-color: #fffcf8;
  transition: all 1s;
  color: #6396f5;
}

.pphc__placehoder:hover {
  transform: scale(1.2);
}

.pc__info-tags-container {
  width: 100%;
  display: flex;
  flex-direction: column;
  height: 100%;
  margin-left: 0.3rem;
}

.pc__plot {
  height: 55%;
  overflow-y: auto;
  margin-top: 0.3rem;
}

.pc__plot-text {
  margin: 0.4rem;
  text-align: justify;
  color: #6f6b6b;
  width: 90%;
}

.pc__tag {
  margin-top: 0.4rem;
}

.pc__info {
  background-color: #f9f9f9;
  color: #6396f5;
  width: 100%;
  height: 90%;
}

.pc__info-title {
  width: 100%;
  margin-top: .5rem;
  text-align: center;
  margin-bottom: .5rem;
}

.pc__info-container {
  position: absolute;
  left: 0;
  top: 0;
  display: flex;
  flex-direction: column;
  height: 100%;
  width: 100%;
}

.pc__img-action {
  position: absolute;
  left: 0;
  bottom: 0.4rem;
  display: flex;
  justify-content: space-between;
  width: 100%;
}

.pc__info-icon {
  color: white;
  background: black;
  padding: 0.1rem;
  border-radius: 25px;
  margin-right: 1rem;
  margin-left: 1rem;
  cursor: pointer;
}

.pc__action-container {
  display: flex;
  justify-content: space-between;
  align-items: center;
  width: 100%;
  height: 10%;
  flex-shrink: 0;
  background-color: white;
}
</style>
